// JavaScript Document
//Code written by Lars Klassen. Special thanks to Rodrigo Keen, Augusto Ruibal, Matt Comi, Saddor

// ###Sets global variables###
var requestFrontData = null;
var retrivedFrontData = null;
var retrivingFrontData = null;
var parsedFrontData = null;
var requestBackData = null;
var retrivedBackData = null;
var requestVoteData = null;
var retriveFrontDatafromWebUpdateTime = 10800000; //3 Hours

var lastStoreUpdate = null;
var leftButtonURL = "http://www.moodyornot.com/";

var firstExpandTimer = null;
var expandTimer = null;
var timeLeftInterval = null;

var isExpanding = null;
var isMouseOver = null;
var isMouseOut = null;

var gFrontHeight, gFrontWidth;

var lastWorldFace = null;

var isFliped = null;

var lastTimeLeft = null;
// ###End of global variables###

//Resets pertinent variables, not all
function resetVariables() {
	requestFrontData = null;
	requestBackData = null;
	retrivedBackData = null;
	requestVoteData = null;
	isExpanding = null;
	isFliped = null;
	lastTimeLeft = null;
	clearAnimationTimers();
	clearBackTimer();
}

//Returns to the default widget state
function resetToFront() {
	document.getElementById("front").style.display = "block";
	document.getElementById("back").style.display = "none";
	document.getElementById("config").style.display = "none";
	document.getElementById("leftBg").style.width = "0px";
	document.getElementById("rightBg").style.width = "0px";
	document.getElementById("timeBg").style.width = "0px";
	resetVariables();
	resetButtons();
	prepareBackSide();
}

//Resets all buttons to their default state
function resetButtons() {
	document.getElementById("leftButton-off").style.opacity = 0;
	document.getElementById("rightButton-off").style.opacity = 0;
	document.getElementById("leftButton-on").style.opacity = 0;
	document.getElementById("rightButton-on").style.opacity = 0;
	document.getElementById("buttonVoteDone").className = "buttonVoteDone-off";
	document.getElementById("buttonVote1").className = "buttonVote1-off";
	document.getElementById("buttonVote2").className = "buttonVote2-off";
	document.getElementById("buttonVote3").className = "buttonVote3-off";
	document.getElementById("buttonVote4").className = "buttonVote4-off";
}

function createkey(key) {
	return widget.identifier + "-" + key;
}


//Function for retriving front data, useful for debugging
function doInitialLoad() {
	resetVariables();
	retriveFrontData();
	prepareBackSide();
	var infobutton = new AppleInfoButton (document.getElementById('buttonInfo'), document.getElementById('front'), "white", "white", clickFlipConfig);
	var done_button = new AppleGlassButton (document.getElementById('buttonConfigDone'), 'Done', clickFlipFrontFromConfig);
}

if (window.widget) {
    widget.onshow = onShow;
	widget.onhide = onHide;
	widget.onremove = onRemove;
}

function onShow() {
	setTimeout("retriveFrontData();",500);
}

function onHide() {
	resetToFront();
	clearNonStoredData();
}

//Cleares stored prefs on widget remove
function onRemove() {
	widget.setPreferenceForKey(null,createkey("lastStoreUpdate"));
	widget.setPreferenceForKey(null,createkey("storeShown"));
	widget.setPreferenceForKey(null,createkey("username"));
	widget.setPreferenceForKey(null,createkey("password"));
	widget.setPreferenceForKey(null,createkey("retrivedFrontData"));
	widget.setPreferenceForKey(null,createkey("retrivedFrontDataTimestamp"));
}

//Retrives Fron Data
function retriveFrontData() {
	var storedFrontDataTimestamp;
	
	var now = new Date();
	var unixNow = Date.parse(now);
	
	if (window.widget) {
		storedFrontDataTimestamp = widget.preferenceForKey(createkey("retrivedFrontDataTimestamp"));
	}
	
	if (storedFrontDataTimestamp === undefined) {
		retriveFrontDataFromWeb();
	} else {
		if (unixNow > (storedFrontDataTimestamp + retriveFrontDatafromWebUpdateTime)) {
			retriveFrontDataFromWeb();
		} else {
			retriveFrontStoredData();
		}
	}
}

function retriveFrontStoredData() {
	if (window.widget) {
		var storedFrontData;
		storedFrontData = widget.preferenceForKey(createkey("retrivedFrontData"));
		
		if (storedFrontData !== undefined) {
			retrivedFrontData = storedFrontData;
			parseFrontData();
		} else {
			retriveFrontDataFromWeb();
		}
	} else {
		retriveFrontDataFromWeb();
	}
}

//Retrives Front Data from the Web
function retriveFrontDataFromWeb() {
	if (!retrivingFrontData) {
		requestFrontData = null;
		retrivingFrontData = 1;
		requestFrontData = new XMLHttpRequest();
		requestFrontData.onreadystatechange = storeFrontData;
		
		url =  "http://feed.moodyornot.com/feed/stats.php";
		
		requestFrontData.open("GET", url, true);
		requestFrontData.send(null);
	}
}

//Parses Front Data using JSON
function storeFrontData() {
	if (requestFrontData.readyState == 4) {
		if (requestFrontData.status == 200) {
			retrivedFrontData = requestFrontData.responseText;
			if (window.widget) {
				var now = new Date();
				var unixNow = Date.parse(now);
				
				widget.setPreferenceForKey(retrivedFrontData,createkey("retrivedFrontData"));
				widget.setPreferenceForKey(unixNow,createkey("retrivedFrontDataTimestamp"));
			}
			retrivingFrontData = null;
			parseFrontData();
		}
	}
}

//Parse Front Data using JSON
function parseFrontData() {
	parsedFrontData = retrivedFrontData.parseJSON();
	document.getElementById("statAlltime").innerHTML = (Math.round(parsedFrontData.ALLTIME.PERCENT * 10)/10) + "%" ;
	document.getElementById("statToday").innerHTML = (Math.round(parsedFrontData.TODAY.PERCENT * 10)/10) + "%" ;
	retriveFrontDatafromWebUpdateTime = parsedFrontData.OSXWIDGET_UPDATETIME;
	
	if (parsedFrontData.TODAY.COMPARED.ALLTIME != lastWorldFace) {
		doUpdateExpand();
	}
}

//Function prioperty of Apple Computer, Inc. Taken from the Rect Sample Code and adapted for Moodyornot.
function doExpandAnimation(direction)
{
	clearAnimationTimers();
	
	
	if (isExpanding == null) {
		switch(direction) {
			case "out":
				gFrontHeight = document.getElementById("leftBg").clientHeight;
				gFrontWidth = document.getElementById("leftBg").clientWidth;
				break;
			case "in":
				gFrontHeight = document.getElementById("leftBg").clientHeight;
				gFrontWidth = document.getElementById("leftBg").clientWidth;
				break;
			case "flip":
				gFrontHeight = document.getElementById("leftBg").clientHeight;
				gFrontWidth = document.getElementById("leftBg").clientWidth;
				break;
			case "timeOut":
				gFrontHeight = document.getElementById("timeBg").clientHeight;
				gFrontWidth = document.getElementById("timeBg").clientWidth;
				break;
			case "timeIn":
				gFrontHeight = document.getElementById("timeBg").clientHeight;
				gFrontWidth = document.getElementById("timeBg").clientWidth;
				break;
			case "flipBack":
				gFrontHeight = document.getElementById("timeBg").clientHeight;
				gFrontWidth = document.getElementById("timeBg").clientWidth;
				break;
			case "flipConfig":
				gFrontHeight = document.getElementById("leftBg").clientHeight;
				gFrontWidth = document.getElementById("leftBg").clientWidth;
				break;
		}
		
		switch(direction) {
			case "out":
				if (gFrontWidth == 115) {
					return;
				}
				var toX = 115;
				checkUpdate();
				checkStore();
				break;
			case "in":
				if (gFrontWidth == 0) {
					return;
				}
				var toX = 0;
				break;
			case "flip":
				if (gFrontWidth == 0) {
					return;
				}
				var toX = 0;
				break;
			case "timeOut":
				if (gFrontWidth == 115) {
					return;
				}
				var toX = 115;
				break;
			case "timeIn":
				if (gFrontWidth == 0) {
					return;
				}
				var toX = 0;
				break;
			case "flipBack":
				if (gFrontWidth == 0) {
					return;
				}
				var toX = 0;
				break;
			case "flipConfig":
				if (gFrontWidth == 0) {
					return;
				}
				var toX = 0;
				break;
		}
		var startingRect = new AppleRect (0, 0, gFrontWidth, gFrontHeight);
		var finishingRect = new AppleRect (0, 0, toX, 65);
		
		switch(direction) {
			case "out":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectFrontHandler );
				break;
			case "in":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectFrontHandler );
				break;
			case "flip":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectFrontHandler );
				break;
			case "timeOut":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectBackHandler );
				break;
			case "timeIn":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectBackHandler );
				break;
			case "flipBack":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectBackHandler );
				break;
			case "flipConfig":
				var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectFrontHandler );
				break;
		}
		
		var currentAnimator = new AppleAnimator (450, 10);
		
		currentAnimator.addAnimation(currentRectAnimation);
		
		switch(direction) {
			case "out":
				currentAnimator.oncomplete = completeExpandAnimationOut;
				break;
			case "in":
				turnFrontButtons('off');
				currentAnimator.oncomplete = completeExpandAnimationIn;
				break;
			case "flip":
				turnFrontButtons('off');
				currentAnimator.oncomplete = doFlipBack;
				break;
			case "timeOut":
				currentAnimator.oncomplete = completeExpandAnimationTimeOut;
				break;
			case "timeIn":
				currentAnimator.oncomplete = completeExpandAnimationTimeIn;
				break;
			case "flipBack":
				currentAnimator.oncomplete = doFlipFront;
				break;
			case "flipConfig":
				turnFrontButtons('off');
				currentAnimator.oncomplete = doFlipConfig;
				break;
		}
		isExpanding = 1;
		currentAnimator.start();
	}
}

//Function prioperty of Apple Computer Inc. Taken from the Rect Sample Code
function rectFrontHandler( rectAnimation, currentRect, startingRect, finishingRect )
{
	document.getElementById("leftBg").style.width = (currentRect.right) + "px";
	document.getElementById("rightBg").style.width = (currentRect.right) + "px";
}
function rectBackHandler( rectAnimation, currentRect, startingRect, finishingRect )
{
	document.getElementById("timeBg").style.width = (currentRect.right) + "px";
}

//The Front Panel Mouse Over function
function doFrontMouseOver() {
	isMouseOver = 1;
	isMouseOut = null;
	if(retrivedFrontData && isFliped == null) {
		doExpandAnimation('out');
	}
}

//The Front Panel Mouse Out function
function doFrontMouseOut() {
	isMouseOver = null;
	isMouseOut = 1;
	if(retrivedFrontData && isFliped == null) {
		clearAnimationTimers();
		expandTimer = setTimeout("doExpandAnimation('in');", 2000);
	}
}

//Expand In Animation when data is retrived is updated
function doAutoExpandAnimationIn() {
	if (isMouseOver == null) { //This avoids the Expandin In Animation when the mouse over the widget (focus)
		doExpandAnimation('in');
	}
	clearAnimationTimers();
}

//Function for when the Expand Out Animation is done
function completeExpandAnimationOut() {
	turnFrontButtons('on');
	isExpanding = null;
}
function completeExpandAnimationIn() {
	isExpanding = null;
}
function completeExpandAnimationTimeOut() {
	isExpanding = null;
}
function completeExpandAnimationTimeIn() {
	isExpanding = null;
	requestBackData = null;
	retrivedBackData = null;
	retriveBackData();
	
}

//Clears Animation timers
function clearAnimationTimers() {
	if(firstExpandTimer != null) {
		clearTimeout(firstExpandTimer);
		firstExpandTimer = null;
	}
	if(expandTimer != null) {
		clearTimeout(expandTimer);
		expandTimer = null;
	}
}
function clearBackTimer() {
	if (timeLeftInterval != null) {
		clearInterval(timeLeftInterval);
		timeLeftInterval = null;
	}
}

//function called once front data is loaded.
function doUpdateExpand() {
	var worldLoading = document.getElementById("worldLoading");
	var worldLoaded = document.getElementById("worldLoaded");
	var fadeLoading = new Fader(worldLoading,null,1500,0,1);
	var fadeLoaded = new Fader(worldLoaded,null,500,0,1);
	if (lastWorldFace == null) {
		worldLoading.className = "wondering";
	} else {
		worldLoading.className = lastWorldFace;
	}
	lastWorldFace = parsedFrontData.TODAY.COMPARED.ALLTIME;
	worldLoaded.className = parsedFrontData.TODAY.COMPARED.ALLTIME;
	worldLoading.style.opacity = 1;
	worldLoaded.style.opacity = 0;
	fadeLoading.fadeOut();
	fadeLoaded.fadeIn();
	
	doExpandAnimation('out');
	firstExpandTimer = setTimeout("doAutoExpandAnimationIn();", 4000);
}

//Turn front buttons On
function turnFrontButtons(type) {
	var leftButton_off = document.getElementById("leftButton-off");
	var rightButton_off = document.getElementById("rightButton-off");
	
	var leftButton_showOff = new Fader(leftButton_off,afterShow,300,0,1);
	var rightButton_showOff = new Fader(rightButton_off,afterShow,300,0,1);
	switch(type) {
		case "on":
			leftButton_showOff.fadeIn();
			rightButton_showOff.fadeIn();
			break;
		case "off":
			leftButton_showOff.fadeOut();
			rightButton_showOff.fadeOut();
			break;
	}
	function afterShow() {
		switch(type) {
			case "on":
				document.getElementById("leftButton-on").style.display = "block";
				document.getElementById("rightButton-on").style.display = "block";
				break;
			case "off":
				document.getElementById("leftButton-on").style.display = "none";
				document.getElementById("rightButton-on").style.display = "none";
				break;
		}
	}
}

//Hover button
function hoverButton(button,type) {
	var divButton = "button" + button;
	var classOff = divButton + "-off";
	var classOn = divButton + "-on";
	switch(type) {
		case "over":
			document.getElementById(divButton).className = classOn;
			break;
		case "out":
			document.getElementById(divButton).className = classOff;
			break;
	}
}

//Hover front buttons
function hoverFrontButtons(button,type) {
	var button = button + "-on";
	var button = document.getElementById(button);
		
	switch(type) {
		case "on":
			button.style.opacity = 1;
			break;
		case "off":
			button.style.opacity = 0;
			break;
	}
}

//Store button
function checkStore() {
	lastStoreUpdate = retrivedFrontData.STORE_UPDATE;
	if (lastStoreUpdate && window.widget) {
		var lastStoreUpdateFromPrefs = widget.preferenceForKey(createkey("lastStoreUpdate"));
		if (lastStoreUpdateFromPrefs == undefined || lastStoreUpdate > lastStoreUpdateFromPrefs) {
			widget.setPreferenceForKey(lastStoreUpdate,createkey("lastStoreUpdate"));
			widget.setPreferenceForKey(0,createkey("storeShown"));
		}
		var storeShownFromPrefs = widget.preferenceForKey("storeShown");
		if (storeShownFromPrefs != undefined && storeShownFromPrefs < 15) {
			document.getElementById("leftButton-off").className = "storeButton-off";
			document.getElementById("leftButton-on").className = "storeButton-on";
			newStoreShown =  storeShownFromPrefs + 1;
			widget.setPreferenceForKey(newStoreShown,createkey("storeShown"));
			leftButtonURL = retrivedFrontData.STORE_URL;
		} else {
			checkUpdate();
		}
	}
}

//Update button
function checkUpdate() {
	var currentVersion = version();
	leftButtonURL = "http://www.moodyornot.com/";
	if (parsedFrontData.OSXWIDGET_BUILD != currentVersion) {
		document.getElementById("leftButton-off").className = "updateButton-off";
		document.getElementById("leftButton-on").className = "updateButton-on";
	} else {
		document.getElementById("leftButton-off").className = "moreButton-off";
		document.getElementById("leftButton-on").className = "moreButton-on";
	}
}

//Widget version
function version() {
    var xmlReq = new XMLHttpRequest(); 
    xmlReq.open("GET", "Info.plist", false); 
    xmlReq.send(null); 
    
    var xml = xmlReq.responseXML; 
    var keys = xml.getElementsByTagName("key");
    var ver = "0";

    for(i=0; i<keys.length; i++) {
	if("CFBundleVersion" == keys[i].firstChild.data){
	    ver = keys[i].nextSibling.nextSibling.firstChild.data;
	    break;
	}
    }

    return ver; 
}

//Opens Moodyornot web
function openWeb() {
	if (widget) {
		widget.openURL(leftButtonURL);
	}
}

/*
########################
###### Vote Panel ######
########################
*/


//Flip to back function
function clickFlipBack() {
	isFliped = 1;
	doExpandAnimation("flip");
}
function doFlipBack() {
	var username;
	if (window.widget) {
		username = widget.preferenceForKey(createkey("username"));
	}
	isExpanding = null;
	resetButtons();
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}
	front.style.display="none";
	back.style.display="block";

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
	}
	
	if (!username) {
		setTimeout("retriveBackData();",500);
	}
}

//Retrives back data
function retriveBackData() {
	requestBackData = null;
	requestBackData = new XMLHttpRequest();
    requestBackData.onreadystatechange = parseBackData;
		
	url =  "http://www.moodyornot.com/feed/vote_OSXD.php";
		
	requestBackData.open("GET", url, true);
    requestBackData.send(null);
}

//Parses back data using JSON
function parseBackData() {
	if (requestBackData.readyState == 4) {
		if (requestBackData.status == 200) {
			lastTimeLeft = null;
			clearBackTimer();
			resetButtons();
			retrivedBackData = requestBackData.responseText.parseJSON();
			enableVote();
		}
	}
}

//Enables either vote options or vote countdown
function enableVote() {
	if (retrivedBackData.TIME == 0) {
		showVoteOptions("on");
	} else {
		setVoteTimer();
		doExpandAnimation("timeOut");
	}
}

//Enables vote countdown
function setVoteTimer() {
	if (lastTimeLeft == null) {
		var timeLeftFromData = retrivedBackData.TIME;
		lastTimeLeft = timeLeftFromData + 10;
		timeLeftInterval = setInterval("setVoteTimer();",1000);
	} else if(lastTimeLeft <= 1) {
		clearBackTimer();
		lastTimeLeft = null;
		doExpandAnimation("timeIn");
	} else {
		lastTimeLeft--;
	}
	var	timeLeftObject = new Date(lastTimeLeft * 1000);
	var minutesLeft = timeLeftObject.getMinutes();
	var secondsLeft = timeLeftObject.getSeconds();
	if (secondsLeft < 10) {
		secondsLeft = "0" + secondsLeft;
	}
	document.getElementById("time").innerHTML = minutesLeft + ":" + secondsLeft;
}

//Enables vote options
function showVoteOptions(type) {
	var voteOptions = document.getElementById("voteOptions");
	var voteOptions_show = new Fader(voteOptions,afterShow,300,0,1);
	switch(type) {
		case "on":
			voteOptions.style.display = "block";
			voteOptions_show.fadeIn();
			break;
		case "off":
			voteOptions_show.fadeOut();
			break;
	}
	function afterShow() {
		if (type == "off") {
			voteOptions.style.display = "none";
		}
	}
}

//Submits chosen vote
function postVote(vote) {
	var username;
	var password;
	if (window.widget) {
		username = widget.preferenceForKey(createkey("username"));
		password = widget.preferenceForKey(createkey("password"));
	}
	
	showVoteOptions("off");
	var url;
    requestVoteData = new XMLHttpRequest();
    requestVoteData.onreadystatechange = onVote;
	
	url =  "http://www.moodyornot.com/feed/vote_OSXD.php";

    requestVoteData.open("POST", url, true);
    if (username && password) {
		requestVoteData.send("mood=" + vote + "&username=" + username + "&password=" + password);
	} else {
		requestVoteData.send("mood=" + vote);
	}
}

function onVote() {
    if(requestVoteData.readyState == 4) {
		if(requestVoteData.status == 200) {
			retrivedBackData = requestVoteData.responseText.parseJSON();
			if (retrivedBackData.USERSTATUS != 1) {
				document.getElementById("worldUserVoteError").style.display = "block";
				document.getElementById("errorMessage").innerHTML = retrivedBackData.USERSTATUS;
			} else {
				doFlipFront();
			}
		}
    }		
}

//Flip to front function
function clickFlipFront() {
	if (document.getElementById("timeBg").clientWidth != 0) {
		doExpandAnimation("flipBack");
	} else {
		doFlipFront();
	}
}
function doFlipFront() {
	isExpanding = null;
	clearBackTimer();
	lastTimeLeft = null;
	resetButtons();
	isFliped = null;
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}
	front.style.display="block";
	back.style.display="none";

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
	}
}

/*
############################
###### Config Panel ########
############################
*/


//Flip to config function
function clickFlipConfig() {
	if (window.widget) {
		var username;
		var password;
		username = widget.preferenceForKey(createkey("username"));
		password = widget.preferenceForKey(createkey("password"));
		
		if (username !== undefined && password !== undefined) {
			document.getElementById('username').value = username;
			document.getElementById('password').value = password;
		}
	}
	isFliped = 1;
	doExpandAnimation("flipConfig");
}

function doFlipConfig() {
	isExpanding = null;
	resetButtons();
	var front = document.getElementById("front");
	var back = document.getElementById("config");
	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}
	front.style.display="none";
	back.style.display="block";

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
	}
}

//Flip to front function
function clickFlipFrontFromConfig() {
	storeUserData();
	prepareBackSide();
	doFlipFrontFromConfig();
}
function doFlipFrontFromConfig() {
	resetButtons();
	isFliped = null;
	
	var front = document.getElementById("front");
	var back = document.getElementById("config");
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}
	front.style.display="block";
	back.style.display="none";

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
	}
}

//Store user data
function storeUserData() {
	if (window.widget) {
		var username;
		var password;
		username = document.getElementById('username').value;
		password = document.getElementById('password').value;
		if (username != "" && password != "") {
			widget.setPreferenceForKey(username,createkey("username"));
			widget.setPreferenceForKey(password,createkey("password"));
		}
		if ((widget.preferenceForKey(createkey("username")) || widget.preferenceForKey(createkey("password"))) && (username == "" || password == "")) {
			widget.setPreferenceForKey(null,createkey("username"));
			widget.setPreferenceForKey(null,createkey("password"));
			document.getElementById('username').value = "";
			document.getElementById('password').value = "";
		}
	}
}
function clearNonStoredData() {
	document.getElementById('username').value = "";
	document.getElementById('password').value = "";
}

//prepares back side
function prepareBackSide() {
	var username;
	if (window.widget) {
		username = widget.preferenceForKey(createkey("username"));
	}
	if (username) {
		document.getElementById("worldWondering").style.display = "none";
		document.getElementById("worldUserVote").style.display = "block";
		document.getElementById("voteOptions").style.opacity = 1;
		document.getElementById("voteOptions").style.display = "block";
		document.getElementById("displayUsername").innerHTML = username;
	} else {
		document.getElementById("worldWondering").style.display = "block";
		document.getElementById("worldUserVote").style.display = "none";
		document.getElementById("voteOptions").style.display = "none";
		document.getElementById("voteOptions").style.opacity = 0;
	}
	document.getElementById("worldUserVoteError").style.display = "none";
	document.getElementById("errorMessage").innerHTML = "";
}

//Config Panel URL Buttons
function openSignup() {
	if (widget) {
		widget.openURL("http://www.moodyornot.com/signup.php");
	}
}
function openForgotPassword() {
	if (widget) {
		widget.openURL("http://www.moodyornot.com/forgotPassword.php");
	}
}